// -*- C++ -*-
//
//  This file is part of Siena, a wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 1998-2002 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: CoveringRelations.h,v 1.3 2002/11/22 20:57:45 carzanig Exp $
//
#ifndef _CoveringRelations_h
#define _CoveringRelations_h

#include <list>

#include <siena/Siena.h>

//
// covering relations
//
extern bool	covers(const Filter &, const Event &);
extern bool	covers(const Filter &, const Filter &);	

extern bool	negates(const Filter &, const Filter &);	

extern Filter &	simplify(Filter &);
//
// difference between filters:
//
// f1 <==> f2 && diff(f1,f2)
//
extern Filter &	diff(Filter & d, const Filter & f1, const Filter & f2);
extern Filter	diff(const Filter & f1, const Filter & f2);
//
// intersection of two filters:
//
// intersection(f1, f2) <==> f1 && f2
//
extern Filter &	intersection(Filter & f1, const Filter & f2);
//
// infix forms
//
extern bool	operator > (const Filter &, const Filter &);
extern Filter	operator - (const Filter &, const Filter &);
extern Filter	operator + (const Filter &, const Filter &);

#ifndef NO_INLINE
#include "CoveringRelations.icc"
#endif

#endif
