#!/bin/sh
#
#  This file is part of Siena, a wide-area event notification system.
#  See http://www.cs.colorado.edu/serl/dot/siena.html
#
#  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
#  See the file AUTHORS for full details. 
#
#  Copyright (C) 1998-1999 University of Colorado
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
#  USA, or send email to serl@cs.colorado.edu.
#
#
# $Id: test_cover.sh,v 1.1 2002/06/10 20:19:15 carzanig Exp $
#
. $SIENAHOME/tests/base.sh
#
cat<<EOF
Tested Feature:		simple filter covering

Topology:		1 server, 1 object, 1 party
Interface functions:	subscribe, unsubscribe, publish
Notification classes:	single attribute
             types:	string, integer, boolean, float
Filter classes:		single attribute, single constraint
       types:		string, integer, boolean, float
       operators:	any > < *
EOF
#
opentest 1 $*
#
# --------------- TEST BEGINS HERE -----------------
#
# ---- {x any} C {x=10}
#
incref
send<<EOF
senp{ to="$siena0" method="SUB" ref=$ref subscriber="$client/1"}
filter{x=10}
EOF
#
incref
send<<EOF
senp{ to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
expect<<EOF
senp{ from="$siena0" method="PUB" ref=$ref to="$client/1" }
event{x=10}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="UNS" ref=$ref subscriber="$client/1"}
filter{x any}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
#
# ---- {x > 2} C {x=10}
#
incref
send<<EOF
senp{ to="$siena0" method="SUB" ref=$ref subscriber="$client/1"}
filter{x=10}
EOF
#
incref
send<<EOF
senp{ to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
expect<<EOF
senp{ from="$siena0" method="PUB" ref=$ref to="$client/1" }
event{x=10}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="UNS" ref=$ref subscriber="$client/1"}
filter{x > 2}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
#
#
# ---- {x != 2} C {x=10}
#
incref
send<<EOF
senp{ to="$siena0" method="SUB" ref=$ref subscriber="$client/1"}
filter{x=10}
EOF
#
incref
send<<EOF
senp{ to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
expect<<EOF
senp{ from="$siena0" method="PUB" ref=$ref to="$client/1" }
event{x=10}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="UNS" ref=$ref subscriber="$client/1"}
filter{x != 2}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
#
# ---- {x < 20} C {x=10}
#
incref
send<<EOF
senp{ to="$siena0" method="SUB" ref=$ref subscriber="$client/1"}
filter{x=10}
EOF
#
incref
send<<EOF
senp{ to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
expect<<EOF
senp{ from="$siena0" method="PUB" ref=$ref to="$client/1" }
event{x=10}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="UNS" ref=$ref subscriber="$client/1"}
filter{x < 20}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
#
# ---- {x <= 20} C {x=10}
#
incref
send<<EOF
senp{ to="$siena0" method="SUB" ref=$ref subscriber="$client/1"}
filter{x=10}
EOF
#
incref
send<<EOF
senp{ to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
expect<<EOF
senp{ from="$siena0" method="PUB" ref=$ref to="$client/1" }
event{x=10}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="UNS" ref=$ref subscriber="$client/1"}
filter{x <= 20}
EOF
#
incref
send<<EOF
senp{to="$siena0" method="PUB" ref=$ref}
event{x=10}
EOF
#
#
closetest $*
